#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_scan(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void open();

	void dofft(float* real, float* imag);
	void fftanalysis();

private:
	float *input1_buffer;
	float *input2_buffer;
	float *input3_buffer;
	float *input4_buffer;
	float *input5_buffer;

	char* filename;
	unsigned short int buffer, hb;

	unsigned short int interpolation;
	unsigned short int ifftinterpolation;
	unsigned short int mode;

	float *output1_buffer;
	float *output2_buffer;

	float samplerate;

	unsigned long int i;
	int j, k;	//	normally local to fft
	float o;

	short nChannels, wBitsPerSample;

	float* left;
	float* right;

	float ol0[32768];
	float ol1[32768];
	float or0[32768];
	float or1[32768];

	float rlb[32768];
	float ilb[32768];
	float rrb[32768];
	float irb[32768];

	float phl[32768];
	float phr[32768];

	unsigned long int samples;
	unsigned long int actualsamples;

	short play;

	unsigned long int p;			//	position (int)
	unsigned long int p0, p1;		//	index for buffer + overlap buffer
	unsigned long int p0b, p1b;		//	previous sample value to check for wraps
	unsigned long int pfr, pfrd;	//	pointer to frame + fractional pointer

	double pf, d;		//	position (float) and decimal portion
	double bpf, bd;		//	same for buffer
	double inc, tinc;
	double incrate;

	bool first;


//	ifft variables

	float* rl;	// real/imaginary left/right
	float* rr;
	float* il;
	float* ir;

	float o0, o1, o2, o3, o4, o5;

	float sine[65536];

	int n;						//	buffer length in samples
	float invn;					//	1 / n

	int nm1, nd2;				//	fft variables dependent on buffer length
	float zr[17];				//	replaced sin/cos
	float zi[17];

	float f0, f1, f2;			//	interpolation variables
	unsigned long int s0, s1, s2, s3;
	unsigned long int z0, z1, z2, z3;

	float srl, srr;				//	for spectral shift
	int shift, sh0, sh1;
	float shd;					//	shift decimal

	bool good;

	float gatebuf, pitchbuf, timebuf, positionbuf;

	bool wake, wakebuf;

	int static_count;
};
#endif
